package cn.com.tenlion.projectconfig.service.projectconfig.impl;

import ink.wgink.common.base.DefaultBaseService;
import ink.wgink.exceptions.RemoveException;
import ink.wgink.exceptions.SaveException;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResult;
import ink.wgink.pojo.result.SuccessResultList;
import ink.wgink.util.map.HashMapUtil;
import ink.wgink.util.UUIDUtil;
import cn.com.tenlion.projectconfig.dao.projectconfig.IProjectConfigDao;
import cn.com.tenlion.projectconfig.pojo.dtos.projectconfig.ProjectConfigDTO;
import cn.com.tenlion.projectconfig.pojo.vos.projectconfig.ProjectConfigVO;
import cn.com.tenlion.projectconfig.pojo.bos.projectconfig.ProjectConfigBO;
import cn.com.tenlion.projectconfig.pojo.pos.projectconfig.ProjectConfigPO;
import cn.com.tenlion.projectconfig.service.projectconfig.IProjectConfigService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @ClassName: ProjectConfigServiceImpl
 * @Description: CBC项目配置管理表
 * @Author: CodeFactory
 * @Date: 2021-08-12 13:54:56
 * @Version: 3.0
 **/
@Service
public class ProjectConfigServiceImpl extends DefaultBaseService implements IProjectConfigService {

    @Autowired
    private IProjectConfigDao projectConfigDao;

    @Override
    public void save(ProjectConfigVO projectConfigVO) {
        saveReturnId(projectConfigVO);
    }

    @Override
    public void save(String token, ProjectConfigVO projectConfigVO) {
        saveReturnId(token, projectConfigVO);
    }

    @Override
    public String saveReturnId(ProjectConfigVO projectConfigVO) {
        return saveReturnId(null, projectConfigVO);
    }

    @Override
    public String saveReturnId(String token, ProjectConfigVO projectConfigVO) {
        /**
         * 判断配置Key是否已经存在 , 如果存在则不允许保存
         */
        projectConfigVO.setProjectConfigKey(projectConfigVO.getProjectConfigKey().trim());
        Map<String, Object> query = getHashMap(3);
        query.put("projectConfigKey", projectConfigVO.getProjectConfigKey());
        ProjectConfigDTO dto = get(query);
        if(dto != null) {
            throw new SaveException("配置Key已存在");
        }
        String projectConfigId = UUIDUtil.getUUID();
        Map<String, Object> params = HashMapUtil.beanToMap(projectConfigVO);
        params.put("projectConfigId", projectConfigId);
        if (StringUtils.isBlank(token)) {
            setSaveInfo(params);
        } else {
            setAppSaveInfo(token, params);
        }
        projectConfigDao.save(params);
        return projectConfigId;
    }

    @Override
    public void remove(List<String> ids) {
        remove(null, ids);
    }

    @Override
    public void remove(String token, List<String> ids) {
        Map<String, Object> params = getHashMap(2);
        for (String id : ids) {
            ProjectConfigDTO dto = get(id);
            if("0".equals(dto.getProjectConfigStatus())) {
                throw new RemoveException(dto.getProjectConfigKey()+"禁止删除");
            }
        }
        params.put("projectConfigIds", ids);
        if (StringUtils.isBlank(token)) {
            setUpdateInfo(params);
        } else {
            setAppUpdateInfo(token, params);
        }
        projectConfigDao.remove(params);
    }

    @Override
    public void delete(List<String> ids) {
        Map<String, Object> params = getHashMap(2);
        params.put("projectConfigIds", ids);
        projectConfigDao.delete(params);
    }

    @Override
    public void update(String projectConfigId, ProjectConfigVO projectConfigVO) {
        update(null, projectConfigId, projectConfigVO);
    }

    @Override
    public void update(String token, String projectConfigId, ProjectConfigVO projectConfigVO) {
        Map<String, Object> params = HashMapUtil.beanToMap(projectConfigVO);
        params.put("projectConfigId", projectConfigId);
        if (StringUtils.isBlank(token)) {
            setUpdateInfo(params);
        } else {
            setAppUpdateInfo(token, params);
        }
        projectConfigDao.update(params);
    }

    @Override
    public ProjectConfigDTO get(Map<String, Object> params) {
        return projectConfigDao.get(params);
    }

    @Override
    public ProjectConfigDTO get(String projectConfigId) {
        Map<String, Object> params = super.getHashMap(2);
        params.put("projectConfigId", projectConfigId);
        return get(params);
    }

    @Override
    public ProjectConfigBO getBO(Map<String, Object> params) {
        return projectConfigDao.getBO(params);
    }

    @Override
    public ProjectConfigBO getBO(String projectConfigId) {
        Map<String, Object> params = super.getHashMap(2);
        params.put("projectConfigId", projectConfigId);
        return getBO(params);
    }

    @Override
    public ProjectConfigPO getPO(Map<String, Object> params) {
        return projectConfigDao.getPO(params);
    }

    @Override
    public ProjectConfigPO getPO(String projectConfigId) {
        Map<String, Object> params = super.getHashMap(2);
        params.put("projectConfigId", projectConfigId);
        return getPO(params);
    }

    @Override
    public List<ProjectConfigDTO> list(Map<String, Object> params) {
        return projectConfigDao.list(params);
    }

    @Override
    public List<ProjectConfigBO> listBO(Map<String, Object> params) {
        return projectConfigDao.listBO(params);
    }

    @Override
    public List<ProjectConfigPO> listPO(Map<String, Object> params) {
        return projectConfigDao.listPO(params);
    }

    @Override
    public SuccessResultList<List<ProjectConfigDTO>> listPage(ListPage page) {
        PageHelper.startPage(page.getPage(), page.getRows());
        List<ProjectConfigDTO> projectConfigDTOs = list(page.getParams());
        PageInfo<ProjectConfigDTO> pageInfo = new PageInfo<>(projectConfigDTOs);
        return new SuccessResultList<>(projectConfigDTOs, pageInfo.getPageNum(), pageInfo.getTotal());
    }

    @Override
    public Integer count(Map<String, Object> params) {
        Integer count = projectConfigDao.count(params);
        return count == null ? 0 : count;
    }

    @Override
    public void updateSwitch(String projectConfigId, Boolean projectConfigSwitch) {
        Map<String, Object> params = HashMapUtil.beanToMap(3);
        params.put("projectConfigId", projectConfigId);
        params.put("projectConfigSwitch", projectConfigSwitch ? "1" : "0");
        setUpdateInfo(params);
        projectConfigDao.updateSwitch(params);
    }

    @Override
    public ProjectConfigDTO getByKey(String configKey) {
        Map<String, Object> params = super.getHashMap(2);
        params.put("projectConfigKey", configKey);
        return get(params);
    }

}